diff --git a/reviewboard/hostingsvcs/base/http.py b/reviewboard/hostingsvcs/base/http.py
index 97db069c54b73ad1feca4411cf6de0bfc677a826..8a7fcb3326d47105eb8cc636b3471d8a80cf463f 100644
--- a/reviewboard/hostingsvcs/base/http.py
+++ b/reviewboard/hostingsvcs/base/http.py
@@ -13,7 +13,7 @@
 import logging
 import ssl
 from collections import OrderedDict
-from typing import Any, Dict, List, NoReturn, Optional, TYPE_CHECKING, Union
+from typing import Any, Dict, TypedDict, TYPE_CHECKING, Union
 from urllib.parse import parse_qs, urlencode, urlparse, urlunparse
 from urllib.request import (
     Request as BaseURLRequest,
@@ -26,7 +26,6 @@
 from django.utils.encoding import force_str
 from djblets.log import log_timed
 from djblets.util.decorators import cached_property
-from typing_extensions import TypeAlias, TypedDict
 
 from reviewboard.deprecation import RemovedInReviewBoard80Warning
 
@@ -34,6 +33,7 @@
     from urllib.request import BaseHandler
 
     from typelets.json import JSONValue
+    from typing_extensions import Never, TypeAlias
 
     from reviewboard.hostingsvcs.base.hosting_service import BaseHostingService
 
@@ -52,21 +52,20 @@
     #:
     #: Type:
     #:      bytes
-    content: Union[bytes, str]
+    content: bytes | str
 
     #: The base name of the file.
     #:
     #: Type:
     #:      bytes
-    filename: Union[bytes, str]
+    filename: bytes | str
 
 
 #: Form field data to set when performing a POST or PUT.
 #:
 #: Version Added:
 #:     6.0
-FormFields: TypeAlias = Dict[Union[bytes, str],
-                             Union[bytes, str]]
+FormFields: TypeAlias = Dict[Union[bytes, str], Union[bytes, str]]
 
 
 #: Type for a mapping of HTTP headers for a request or response.
@@ -91,19 +90,27 @@
 
 
 def _log_and_raise(
+    value: Never,
     request: HostingServiceHTTPRequest,
     msg: str,
     **fmt_dict,
-) -> NoReturn:
+) -> Never:
     """Log and raise an exception with the given message.
 
     This is used when validating data going into the request, and is
     intended to help with debugging bad calls to the HTTP code.
 
+    Version Changed:
+        7.1:
+        Modified to take in the offending value.
+
     Version Added:
         4.0
 
     Args:
+        value (object):
+            The value which was not valid.
+
         request (HostingServiceHTTPRequest):
             The HTTP request.
 
@@ -117,7 +124,7 @@
         TypeError:
             The exception containing the provided message.
     """
-    msg = msg % dict({
+    msg %= dict({
         'method': request.method,
         'service': type(request.hosting_service),
     }, **fmt_dict)
@@ -150,7 +157,7 @@
     #:
     #: Type:
     #:     bytes
-    body: Optional[bytes]
+    body: bytes | None
 
     #: The headers to send in the request.
     #:
@@ -162,7 +169,7 @@
     #:
     #: Type:
     #:     HostingService
-    hosting_service: Optional[BaseHostingService]
+    hosting_service: BaseHostingService | None
 
     #: The HTTP method to perform.
     #:
@@ -174,7 +181,7 @@
     #:
     #: Type:
     #:     dict
-    query: Optional[QueryArgs]
+    query: QueryArgs | None
 
     #: The URL the request is being made to.
     #:
@@ -186,16 +193,16 @@
     #:
     #: Type:
     #:     list
-    _urlopen_handlers: List[BaseHandler]
+    _urlopen_handlers: list[BaseHandler]
 
     def __init__(
         self,
         url: str,
-        query: Optional[QueryArgs] = None,
-        body: Optional[bytes] = None,
-        headers: Optional[HTTPHeaders] = None,
+        query: (QueryArgs | None) = None,
+        body: (bytes | None) = None,
+        headers: (HTTPHeaders | None) = None,
         method: str = 'GET',
-        hosting_service: Optional[BaseHostingService] = None,
+        hosting_service: (BaseHostingService | None) = None,
         **kwargs,
     ) -> None:
         """Initialize the request.
@@ -236,6 +243,7 @@
 
         if body is not None and not isinstance(body, bytes):
             _log_and_raise(
+                body,
                 self,
                 'Received non-bytes body for the HTTP request for '
                 '%(service)r. This is likely an implementation problem. '
@@ -270,19 +278,19 @@
         self._urlopen_handlers = []
 
     @property
-    def data(self) -> Optional[bytes]:
+    def data(self) -> bytes | None:
         """The payload data for the request.
 
         Deprecated:
             4.0:
             This is deprecated in favor of the :py:attr:`body` attribute.
         """
+        class_name = type(self).__name__
+
         RemovedInReviewBoard80Warning.warn(
-            '%(class_name)s.data is deprecated in favor of '
-            '%(class_name)s.body. This will be removed in Review Board 8.'
-            % {
-                'class_name': type(self).__name__,
-            })
+            f'{class_name}.data is deprecated in favor of '
+            f'{class_name}.body. This will be removed in Review Board 8.'
+        )
 
         return self.body
 
@@ -300,24 +308,35 @@
             value (str):
                 The header value.
         """
-        if (not isinstance(name, str) or
-            not isinstance(value, str)):
-            _log_and_raise(
-                self,
-                'Received non-Unicode header %(header)r (value=%(value)r) '
-                'for the HTTP request for %(service)r. This is likely an '
-                'implementation problem. Please make sure only Unicode '
-                'strings are sent in request headers.',
-                header=name,
-                value=value)
+        if not isinstance(name, str):
+            _log_and_raise(
+                name,
+                self,
+                'Received non-Unicode header name %(header)r '
+                '(value=%(data)r) for the HTTP request for %(service)r. '
+                'This is likely an implementation problem. Please make sure '
+                'only Unicode strings are sent in request headers.',
+                header=name,
+                data=value)
+
+        if not isinstance(value, str):
+            _log_and_raise(
+                value,
+                self,
+                'Received non-Unicode header value for %(header)r '
+                '(value=%(data)r) for the HTTP request for %(service)r. This '
+                'is likely an implementation problem. Please make sure only '
+                'Unicode strings are sent in request headers.',
+                header=name,
+                data=value)
 
         self.headers[name.capitalize()] = value
 
     def get_header(
         self,
         name: str,
-        default: Optional[str] = None,
-    ) -> Optional[str]:
+        default: (str | None) = None,
+    ) -> str | None:
         """Return a header from the request.
 
         Args:
@@ -332,15 +351,15 @@
             The header value.
         """
         assert isinstance(name, str), (
-            '%s.get_header() requires a Unicode header name'
-            % type(self).__name__)
+            f'{type(self).__name__}.get_header() requires a Unicode header '
+            f'name')
 
         return self.headers.get(name.capitalize(), default)
 
     def add_basic_auth(
         self,
-        username: Union[bytes, str],
-        password: Union[bytes, str],
+        username: bytes | str,
+        password: bytes | str,
     ) -> None:
         """Add HTTP Basic Authentication headers to the request.
 
@@ -358,8 +377,10 @@
             password = password.encode('utf-8')
 
         auth = b'%s:%s' % (username, password)
+        encoded = force_str(base64.b64encode(auth))
+
         self.add_header(HTTPBasicAuthHandler.auth_header,
-                        'Basic %s' % force_str(base64.b64encode(auth)))
+                        f'Basic {encoded}')
 
     def add_digest_auth(
         self,
@@ -376,7 +397,7 @@
                 The password.
         """
         result = urlparse(self.url)
-        top_level_url = '%s://%s' % (result.scheme, result.netloc)
+        top_level_url = f'{result.scheme}://{result.netloc}'
 
         password_mgr = HTTPPasswordMgrWithDefaultRealm()
         password_mgr.add_password(None, top_level_url, username, password)
@@ -517,7 +538,7 @@
         self,
         request: HostingServiceHTTPRequest,
         url: str,
-        data: bytes,
+        data: bytes | None,
         headers: HTTPHeaders,
         status_code: int,
     ) -> None:
@@ -543,38 +564,53 @@
         """
         self.request = request
 
-        if data is not None and not isinstance(data, bytes):
+        if data is None:
+            data = b''
+        elif not isinstance(data, bytes):
             # HTTP response data will be in byte strings, unless something is
             # overridden. Users should never see this in production, but
             # it'll be confusing for development. Make sure developers see
             # this through both a log message and an exception.
             _log_and_raise(
+                data,
                 request,
                 'Received non-byte data from the HTTP %(method)s request '
                 'for %(service)r. This is likely an implementation '
                 'problem in a unit test or subclass. Please make sure '
                 'only byte strings are sent.')
 
-        if headers is None:
+        if not isinstance(headers, dict):
             _log_and_raise(
+                headers,
                 request,
-                'Headers response for HTTP %(method)s request for '
-                '%(service)r is None. This is likely an implementation '
-                'problem in a unit test. Please make sure a dictionary '
-                'is returned.')
+                'Headers response for HTTP %(method)s request for %(service)r '
+                'is not a dict. This is likely an implementation problem in a '
+                'unit test. Please make sure a dictionary is returned.')
 
         new_headers: HTTPHeaders = {}
 
         for key, value in headers.items():
-            if not isinstance(key, str) or not isinstance(value, str):
+            if not isinstance(key, str):
                 _log_and_raise(
+                    key,
                     request,
-                    'Received non-native string header %(header)r from the '
+                    'Received non string header %(header)r from the '
                     'HTTP %(method)s request for %(service)r. This is likely '
                     'an implementation problem in a unit test. Please '
-                    'make sure only native strings are sent.',
+                    'make sure only strings are sent.',
                     header=key)
 
+            if not isinstance(value, str):
+                _log_and_raise(
+                    value,
+                    request,
+                    'Received non string header value %(header)r '
+                    '(key=%(key)r) from the HTTP %(method)s request for '
+                    '%(service)r. This is likely an implementation problem in '
+                    'a unit test. Please make sure only strings are  sent.',
+                    key=key,
+                    header=value)
+
             new_headers[key.capitalize()] = value
 
         self.url = url
@@ -602,8 +638,8 @@
     def get_header(
         self,
         name: str,
-        default: Optional[str] = None,
-    ) -> Optional[str]:
+        default: (str | None) = None,
+    ) -> str | None:
         """Return the value of a header as a Unicode string.
 
         This accepts a header name with any form of capitalization. The header
@@ -652,13 +688,13 @@
             IndexError:
                 An index other than 0 or 1 was requested.
         """
+        class_name = type(self).__name__
+
         RemovedInReviewBoard80Warning.warn(
-            'Accessing %(class_name)s by index is deprecated. Please use '
-            '%(class_name)s.data or %(class_name)s.headers instead. This '
+            f'Accessing {class_name} by index is deprecated. Please use '
+            f'{class_name}.data or {class_name}.headers instead. This '
             'will be removed in Review Board 8.'
-            % {
-                'class_name': type(self).__name__,
-            })
+        )
 
         if i == 0:
             return self.data
diff --git a/reviewboard/hostingsvcs/base/paginator.py b/reviewboard/hostingsvcs/base/paginator.py
index ff8219106a59a228be95f3607447b58f338ec018..924e97dad7c93d256155b22c8bd2d0c7a1da8619 100644
--- a/reviewboard/hostingsvcs/base/paginator.py
+++ b/reviewboard/hostingsvcs/base/paginator.py
@@ -8,12 +8,14 @@
 
 from __future__ import annotations
 
-from typing import (Any, Callable, Generic, Iterator, Optional, Sequence,
-                    TYPE_CHECKING, TypeVar)
+from collections.abc import Callable, Sequence
+from typing import Any, Generic, TYPE_CHECKING, TypeVar, Union
 
 from typing_extensions import NotRequired, TypeAlias, TypedDict
 
 if TYPE_CHECKING:
+    from collections.abc import Iterator
+
     from typelets.funcs import KwargsDict
 
     from reviewboard.hostingsvcs.base import HostingServiceClient
@@ -28,8 +30,8 @@
 #:
 #: Version Added:
 #:     6.0
-_ProxyNormalizePageDataFunc: TypeAlias = Callable[[Optional[Any]],
-                                                  Optional[_PageDataT]]
+_ProxyNormalizePageDataFunc: TypeAlias = Callable[[Any],
+                                                  Union[_PageDataT, None]]
 
 
 class APIPaginatorPageData(TypedDict):
@@ -55,19 +57,19 @@
     #:
     #: Type:
     #:     str
-    next_url: NotRequired[Optional[str]]
+    next_url: NotRequired[str | None]
 
     #: The optional limit on the number of items fetched on each page.
     #:
     #: Type:
     #:     int
-    per_page: NotRequired[Optional[int]]
+    per_page: NotRequired[int | None]
 
     #: The optional URL to the previous page.
     #:
     #: Type:
     #:     str
-    prev_url: NotRequired[Optional[str]]
+    prev_url: NotRequired[str | None]
 
     #: The API response data.
     #:
@@ -79,7 +81,7 @@
     #:
     #: Type:
     #:     int
-    total_count: NotRequired[Optional[int]]
+    total_count: NotRequired[int | None]
 
 
 class InvalidPageError(Exception):
@@ -118,13 +120,13 @@
     #:
     #: Type:
     #:     object
-    page_data: Optional[_PageDataT]
+    page_data: _PageDataT | None
 
     #: The number of items to fetch per page.
     #:
     #: Type:
     #:     int
-    per_page: Optional[int]
+    per_page: int | None
 
     #: Keyword arguments to pass when making HTTP requests.
     #:
@@ -138,7 +140,7 @@
     #:
     #: Type:
     #:     int
-    start: Optional[int]
+    start: int | None
 
     #: The total number of results across all pages.
     #:
@@ -146,13 +148,13 @@
     #:
     #: Type:
     #:     int
-    total_count: Optional[int]
+    total_count: int | None
 
     def __init__(
         self,
-        start: Optional[int] = None,
-        per_page: Optional[int] = None,
-        request_kwargs: Optional[KwargsDict] = None,
+        start: (int | None) = None,
+        per_page: (int | None) = None,
+        request_kwargs: (KwargsDict | None) = None,
     ) -> None:
         """Initialize the paginator.
 
@@ -197,7 +199,7 @@
         """
         raise NotImplementedError
 
-    def prev(self) -> Optional[_PageDataT]:
+    def prev(self) -> _PageDataT | None:
         """Fetch the previous page, returning the page data.
 
         Subclasses must override this to provide the logic for fetching pages.
@@ -215,7 +217,7 @@
         """
         raise NotImplementedError
 
-    def next(self) -> Optional[_PageDataT]:
+    def next(self) -> _PageDataT | None:
         """Fetch the next page, returning the page data.
 
         Subclasses must override this to provide the logic for fetching pages.
@@ -235,7 +237,7 @@
 
     def iter_items(
         self,
-        max_pages: Optional[int] = None,
+        max_pages: (int | None) = None,
     ) -> Iterator[_PageDataItemT]:
         """Iterate through all items across pages.
 
@@ -256,18 +258,18 @@
         for page in self.iter_pages(max_pages=max_pages):
             if page:
                 assert isinstance(page, Sequence), (
-                    "page_data is not a sequence (it's a %s). This is "
-                    "either an unexpected result, or %s.iter_items() needs "
-                    "to be overridden."
-                    % (type(page), type(self).__name__)
+                    f"page_data is not a sequence (it's a {type(page)}). This "
+                    f"is either an unexpected result, or "
+                    f"{type(self).__name__}.iter_items() needs to be "
+                    "overridden."
                 )
 
                 yield from page
 
     def iter_pages(
         self,
-        max_pages: Optional[int] = None,
-    ) -> Iterator[Optional[_PageDataT]]:
+        max_pages: (int | None) = None,
+    ) -> Iterator[_PageDataT | None]:
         """Iterate through pages of results.
 
         This will repeatedly fetch pages, providing each parsed page payload
@@ -298,7 +300,7 @@
         except InvalidPageError:
             pass
 
-    def __iter__(self) -> Iterator[Optional[_PageDataT]]:
+    def __iter__(self) -> Iterator[_PageDataT | None]:
         """Iterate through pages of results.
 
         This is a simple wrapper for :py:meth:`iter_pages`.
@@ -342,7 +344,7 @@
     #:
     #: Type:
     #:     str
-    start_query_param: Optional[str] = None
+    start_query_param: (str | None) = None
 
     #: Query parameter name for the requested number of results per page.
     #:
@@ -351,7 +353,7 @@
     #:
     #: Type:
     #:     str
-    per_page_query_param: Optional[str] = None
+    per_page_query_param: (str | None) = None
 
     ######################
     # Instance variables #
@@ -367,25 +369,25 @@
     #:
     #: Type:
     #:     str
-    next_url: Optional[str]
+    next_url: str | None
 
     #: HTTP headers returned for the current page.
     #:
     #: Type:
     #:     dict
-    page_headers: Optional[HTTPHeaders]
+    page_headers: HTTPHeaders | None
 
     #: The URL for the previous set of results in the page.
     #:
     #: Type:
     #:     str
-    prev_url: Optional[str]
+    prev_url: str | None
 
     #: The URL used to fetch the current page of data.
     #:
     #: Type:
     #:     str
-    url: Optional[str]
+    url: str | None
 
     def __init__(
         self,
@@ -457,7 +459,7 @@
         """
         return self.next_url is not None
 
-    def prev(self) -> Optional[_PageDataT]:
+    def prev(self) -> _PageDataT | None:
         """Fetch the previous page, returning the page data.
 
         Returns:
@@ -477,7 +479,7 @@
         self.url = self.prev_url
         return self._fetch_page()
 
-    def next(self) -> Optional[_PageDataT]:
+    def next(self) -> _PageDataT | None:
         """Fetch the next page, returning the page data.
 
         Returns:
@@ -517,7 +519,7 @@
         """
         raise NotImplementedError
 
-    def _fetch_page(self) -> Optional[_PageDataT]:
+    def _fetch_page(self) -> _PageDataT | None:
         """Fetch a page and extracts the information from it.
 
         Returns:
@@ -538,36 +540,34 @@
         self.total_count = page_info.get('total_count')
 
         # Make sure the implementation sent the correct data to us.
-        assert self.prev_url is None or isinstance(self.prev_url, str), \
-            ('"prev_url" result from fetch_url() must be None or Unicode '
-             'string, not %r'
-             % type(self.prev_url))
+        assert self.prev_url is None or isinstance(self.prev_url, str), (
+            f'"prev_url" result from fetch_url() must be None or Unicode '
+            f'string, not {type(self.prev_url)!r}'
+        )
 
-        assert self.next_url is None or isinstance(self.next_url, str), \
-            ('"next_url" result from fetch_url() must be None or Unicode '
-             'string, not %r'
-             % type(self.next_url))
+        assert self.next_url is None or isinstance(self.next_url, str), (
+            f'"next_url" result from fetch_url() must be None or Unicode '
+            f'string, not {type(self.next_url)!r}'
+        )
 
-        assert self.total_count is None or isinstance(self.total_count, int), \
-            ('"total_count" result from fetch_url() must be None or int, not '
-             '%r'
-             % type(self.total_count))
+        assert self.total_count is None or isinstance(self.total_count, int), (
+            f'"total_count" result from fetch_url() must be None or int, not '
+            f'{type(self.total_count)!r}'
+        )
 
-        assert self.per_page is None or isinstance(self.per_page, int), \
-            ('"per_page" result from fetch_url() must be an int, not %r'
-             % type(self.per_page))
+        assert self.per_page is None or isinstance(self.per_page, int), (
+            f'"per_page" result from fetch_url() must be an int, not '
+            f'{type(self.per_page)!r}'
+        )
 
-        assert isinstance(self.page_headers, dict), \
-            ('"page_headers" result from fetch_url() must be a dictionary, '
-             'not %r'
-             % type(self.page_headers))
+        assert isinstance(self.page_headers, dict), (
+            f'"page_headers" result from fetch_url() must be a dictionary, '
+            f'not {type(self.page_headers)!r}'
+        )
 
         return self.page_data
 
 
-_ProxiedPaginatorT = TypeVar('_ProxiedPaginatorT', bound=BasePaginator)
-
-
 class ProxyPaginator(BasePaginator[_PageDataItemT, _PageDataT]):
     """A paginator that proxies to another paginator, transforming data.
 
@@ -605,12 +605,16 @@
     #:
     #: Type:
     #:     callable
-    normalize_page_data_func: Optional[_ProxyNormalizePageDataFunc]
+    normalize_page_data_func: (
+        _ProxyNormalizePageDataFunc[_PageDataItemT] | None
+    )
 
     def __init__(
         self,
         paginator: BasePaginator[Any, Any],
-        normalize_page_data_func: Optional[_ProxyNormalizePageDataFunc] = None,
+        normalize_page_data_func: (
+            _ProxyNormalizePageDataFunc[_PageDataItemT] | None
+        ) = None,
     ) -> None:
         """Initialize the paginator.
 
@@ -647,7 +651,7 @@
         return self.paginator.has_next
 
     @property
-    def per_page(self) -> Optional[int]:  # type: ignore
+    def per_page(self) -> int | None:
         """The number of items requested per page.
 
         Type:
@@ -656,7 +660,7 @@
         return self.paginator.per_page
 
     @property
-    def total_count(self) -> Optional[int]:  # type: ignore
+    def total_count(self) -> int | None:
         """The number of items across all pages, if known.
 
         Type:
@@ -664,7 +668,7 @@
         """
         return self.paginator.total_count
 
-    def prev(self) -> Optional[_PageDataT]:
+    def prev(self) -> _PageDataT | None:
         """Fetch the previous page, returning the page data.
 
         Returns:
@@ -680,7 +684,7 @@
         """
         return self._process_page(self.paginator.prev())
 
-    def next(self) -> Optional[_PageDataT]:
+    def next(self) -> _PageDataT | None:
         """Fetch the next page, returning the page data.
 
         Returns:
@@ -698,8 +702,8 @@
 
     def normalize_page_data(
         self,
-        data: Optional[Any],
-    ) -> Optional[_PageDataT]:
+        data: Any,
+    ) -> _PageDataT | None:
         """Normalize a page of data.
 
         If :py:attr:`normalize_page_data_func` was passed on construction, this
@@ -724,8 +728,8 @@
 
     def _process_page(
         self,
-        page_data: Optional[Any],
-    ) -> Optional[_PageDataT]:
+        page_data: Any,
+    ) -> _PageDataT | None:
         """Process a page of data.
 
         This will normalize the page data, store it, and return it.
diff --git a/reviewboard/hostingsvcs/base/registry.py b/reviewboard/hostingsvcs/base/registry.py
index 227237f222c7d69bb3033df52b8c34cebdc78717..f4e38b55123607549db30cac30b429cedcac14e8 100644
--- a/reviewboard/hostingsvcs/base/registry.py
+++ b/reviewboard/hostingsvcs/base/registry.py
@@ -12,7 +12,7 @@
 import logging
 import re
 from importlib import import_module
-from typing import Dict, Iterator, Optional, Sequence, TYPE_CHECKING, Type
+from typing import TYPE_CHECKING
 
 from django.urls import include, re_path
 from django.utils.translation import gettext_lazy as _
@@ -25,13 +25,16 @@
 from reviewboard.registries.registry import EntryPointRegistry
 
 if TYPE_CHECKING:
+    from collections.abc import Iterator, Sequence
+    from importlib.metadata import EntryPoint
+
     from django.urls import _AnyURL
 
 
 logger = logging.getLogger(__name__)
 
 
-class HostingServiceRegistry(EntryPointRegistry[Type[BaseHostingService]]):
+class HostingServiceRegistry(EntryPointRegistry[type[BaseHostingService]]):
     """A registry for managing hosting services.
 
     Version Changed:
@@ -64,15 +67,15 @@
     #:
     #: Type:
     #:     dict
-    _url_patterns: Dict[str, Sequence[_AnyURL]]
+    _url_patterns: dict[str, Sequence[_AnyURL]]
 
-    def __init__(self):
+    def __init__(self) -> None:
         """Initialize the registry."""
         super().__init__()
 
         self._url_patterns = {}
 
-    def get_defaults(self) -> Iterator[Type[BaseHostingService]]:
+    def get_defaults(self) -> Iterator[type[BaseHostingService]]:
         """Yield the built-in hosting services.
 
         This will make sure the standard hosting services are always present in
@@ -106,7 +109,8 @@
                 ('unfuddle', 'Unfuddle'),
                 ('versionone', 'VersionOne'),
             ):
-            mod = import_module('reviewboard.hostingsvcs.%s' % _module)
+            mod = import_module(f'reviewboard.hostingsvcs.{_module}')
+
             yield getattr(mod, _service_cls_name)
 
         yield from super().get_defaults()
@@ -114,7 +118,7 @@
     def get_hosting_service(
         self,
         hosting_service_id: str,
-    ) -> Optional[Type[BaseHostingService]]:
+    ) -> type[BaseHostingService] | None:
         """Return a hosting service with the given ID.
 
         Args:
@@ -132,7 +136,7 @@
 
     def unregister(
         self,
-        service: Type[BaseHostingService],
+        service: type[BaseHostingService],
     ) -> None:
         """Unregister a hosting service.
 
@@ -164,10 +168,8 @@
         defined.
 
         Args:
-            service (type):
-                The
-                :py:class:`~reviewboard.hostingsvcs.base.hosting_service.
-                BaseHostingService` subclass.
+            hosting_service_id (str):
+                The ID of the hosting service to unregister.
         """
         try:
             self.unregister_by_attr('hosting_service_id', hosting_service_id)
@@ -179,8 +181,8 @@
 
     def process_value_from_entry_point(
         self,
-        entry_point,
-    ) -> Type[BaseHostingService]:
+        entry_point: EntryPoint,
+    ) -> type[BaseHostingService]:
         """Load the class from the entry point.
 
         The ``hosting_service_id`` attribute will be set on the class from the
@@ -203,7 +205,7 @@
 
     def register(
         self,
-        service: Type[BaseHostingService],
+        service: type[BaseHostingService],
     ) -> None:
         """Register a hosting service.
 
@@ -220,9 +222,10 @@
         if service.repository_url_patterns:
             assert service.hosting_service_id
 
+            escaped_id = re.escape(service.hosting_service_id)
+
             cls_urlpatterns = [
-                re_path(r'^(?P<hosting_service_id>%s)/'
-                        % re.escape(service.hosting_service_id),
+                re_path(rf'^(?P<hosting_service_id>{escaped_id})/',
                         include(service.repository_url_patterns)),
             ]
 
diff --git a/reviewboard/hostingsvcs/base/repository.py b/reviewboard/hostingsvcs/base/repository.py
index 79b2516805243bee048b2c15ec0515ce511a8b53..917462c74b226df9ec8793834931b3ed20bd2baa 100644
--- a/reviewboard/hostingsvcs/base/repository.py
+++ b/reviewboard/hostingsvcs/base/repository.py
@@ -7,7 +7,7 @@
 
 from __future__ import annotations
 
-from typing import Optional, TYPE_CHECKING
+from typing import TYPE_CHECKING
 
 if TYPE_CHECKING:
     from typelets.json import JSONDict
@@ -61,7 +61,7 @@
     #:
     #: Type:
     #:     str
-    mirror_path: Optional[str]
+    mirror_path: str | None
 
     #: The displayed name of the repository.
     #:
@@ -95,8 +95,8 @@
         owner: str,
         scm_type: str,
         path: str,
-        mirror_path: Optional[str] = None,
-        extra_data: JSONDict = {},
+        mirror_path: (str | None) = None,
+        extra_data: (JSONDict | None) = None,
     ) -> None:
         """Initialize the remote repository representation.
 
@@ -134,7 +134,7 @@
         self.scm_type = scm_type
         self.path = path
         self.mirror_path = mirror_path
-        self.extra_data = extra_data
+        self.extra_data = extra_data or {}
 
     def __repr__(self) -> str:
         """Return a representation of the remote repository information.
@@ -143,5 +143,7 @@
             str:
             The string representation.
         """
-        return ('<RemoteRepository: "%s" (owner=%s, scm_type=%s)>'
-                % (self.name, self.owner, self.scm_type))
+        return (
+            f'<RemoteRepository: "{self.name}" (owner={self.owner}, '
+            f'scm_type={self.scm_type})>'
+        )
